let authToken = '';
let ws = null;

const APP_DIR = "/usr/local/packages/storeoccupancymanager";
const IMG_SERVICE = "/local/storeoccupancymanager/api/public_image.cgi";
const API = "/local/storeoccupancymanager/api/";
let protocol = location.protocol !== 'https:' ? 'http' : 'https';
$(document).ready(async function() {
  const urlParams = new URLSearchParams(window.location.search);
  authToken = urlParams.get('token');
  var errorcount = 0;
  while (true) {

    try {
      let data = await getData(API + "counter_output.cgi");
      showData(data.data);
      errorcount = 0;
    } catch(err) {
      errorcount++;
      if (errorcount > 5){
        showError(err);
      }
    }
    await sleep(1000);
  }
});

function sleep(ms) {
  return new Promise(resolve => setTimeout(resolve, ms));
}

async function getData(url) {
  try {
    const result = await $.get({
      "url": url,
      "data":{
        "token": authToken
      }
    });
    return result;
  } catch(err) {
      throw new Error('Counting camera not available');
  }
}

function showData(data) {
  $("#max_capacity_label").text(data.label_max_capacity);
  $("#may_enter_label").text(data.label_may_enter);
  $("#in_store_label").text(data.label_in_store);
  $("#max_capacity_data").text(data.max_limit);
  $("#in_store_data").text(data.in_store);
  $("#may_enter_data").text(data.may_enter);
  $("#counter_panel").css("display","block");
  $("#img_container").css("display","block");
  $("#error_msg").css("display","none");
  let img_path = IMG_SERVICE + "?path=" + encodeURIComponent(data.img)+"&token="+encodeURIComponent(authToken);
  $("#img_container").html("<img id=\"render\" src=\"" + img_path + "\">");
  if (data.may_enter > 0) {
    $("body").css("background-color","#34be00");
  } else {
    $("body").css("background-color","red");
  }
}

function showError(err) {
  $("body").css("background-color","black");
  $("#error_msg").html(err);
  $("#error_msg").css("display","block");
  $("#img_container").css("display","none");
  $("#counter_panel").css("display","none");
  $(".data").text("");
  $(".label").text("");
}

function Uint8ToString(u8a) {
  var CHUNK_SZ = 0x8000;
  var c = [];
  for (var i=0; i < u8a.length; i+=CHUNK_SZ) {
    c.push(String.fromCharCode.apply(null, u8a.subarray(i, i+CHUNK_SZ)));
  }
  return c.join("");
}